Package org.apache.commons.math3.distribution

# Class WeibullDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.WeibullDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class WeibullDistribution extends AbstractRealDistribution
Implementation of the Weibull distribution. This implementation uses the two parameter form of the distribution defined by Weibull Distribution, equations (1) and (2).

Since:
  1.1 (changed to concrete class in 3.0)
See Also:
  - Weibull distribution (Wikipedia)
  - Weibull distribution (MathWorld)
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`DEFAULT_INVERSE_ABSOLUTE_ACCURACY`
Default inverse cumulative probability accuracy.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`WeibullDistribution(double alpha, double beta)`
Create a Weibull distribution with the given shape and scale and a location equal to zero.
`WeibullDistribution(double alpha, double beta, double inverseCumAccuracy)`
Create a Weibull distribution with the given shape, scale and inverse cumulative probability accuracy and a location equal to zero.
`WeibullDistribution(RandomGenerator rng, double alpha, double beta)`
Creates a Weibull distribution.
`WeibullDistribution(RandomGenerator rng, double alpha, double beta, double inverseCumAccuracy)`
Creates a Weibull distribution.

## Method Summary

Modifier and Type
Method
Description
`protected double`
`calculateNumericalMean()`
used by `getNumericalMean()`
`protected double`
`calculateNumericalVariance()`
used by `getNumericalVariance()`
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`double`
`getScale()`
Access the scale parameter, `beta`.
`double`
`getShape()`
Access the shape parameter, `alpha`.
`protected double`
`getSolverAbsoluteAccuracy()`
Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`double`
`inverseCumulativeProbability(double p)`
Computes the quantile function of this distribution.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.
`double`
`logDensity(double x)`
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, probability, probability, reseedRandomGenerator, sample, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY
Default inverse cumulative probability accuracy.

Since:
  2.1
See Also:
  - Constant Field Values

## Constructor Details

### WeibullDistribution

public WeibullDistribution(double alpha, double beta) throws NotStrictlyPositiveException
Create a Weibull distribution with the given shape and scale and a location equal to zero.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `AbstractRealDistribution.sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `alpha` - Shape parameter.
  `beta` - Scale parameter.
Throws:
  `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.

### WeibullDistribution

public WeibullDistribution(double alpha, double beta, double inverseCumAccuracy)
Create a Weibull distribution with the given shape, scale and inverse cumulative probability accuracy and a location equal to zero.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `AbstractRealDistribution.sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `alpha` - Shape parameter.
  `beta` - Scale parameter.
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.
Since:
  2.1

### WeibullDistribution

public WeibullDistribution(RandomGenerator rng, double alpha, double beta) throws NotStrictlyPositiveException
Creates a Weibull distribution.

Parameters:
  `rng` - Random number generator.
  `alpha` - Shape parameter.
  `beta` - Scale parameter.
Throws:
  `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.
Since:
  3.3

### WeibullDistribution

public WeibullDistribution(RandomGenerator rng, double alpha, double beta, double inverseCumAccuracy) throws NotStrictlyPositiveException
Creates a Weibull distribution.

Parameters:
  `rng` - Random number generator.
  `alpha` - Shape parameter.
  `beta` - Scale parameter.
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `alpha <= 0` or `beta <= 0`.
Since:
  3.1

## Method Details

### getShape

public double getShape()
Access the shape parameter, `alpha`.

Returns:
  the shape parameter, `alpha`.

### getScale

public double getScale()
Access the scale parameter, `beta`.

Returns:
  the scale parameter, `beta`.

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### logDensity

public double logDensity(double x)
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient. Note that due to the floating point precision and under/overflow issues, this method will for some distributions be more precise and faster than computing the logarithm of `RealDistribution.density(double)`. The default implementation simply computes the logarithm of `density(x)`.

Overrides:
  `logDensity` in class `AbstractRealDistribution`
Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the logarithm of the value of the probability density function at point `x`

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### inverseCumulativeProbability

public double inverseCumulativeProbability(double p)
Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is

- `inf{x in R | P(Xinvalid input: '<'=x) >= p}` for `0 < p <= 1`,
- `inf{x in R | P(Xinvalid input: '<'=x) > 0}` for `p = 0`.

The default implementation returns

- `RealDistribution.getSupportLowerBound()` for `p = 0`,
- `RealDistribution.getSupportUpperBound()` for `p = 1`.

Returns `0` when `p == 0` and `Double.POSITIVE_INFINITY` when `p == 1`.

Specified by:
  `inverseCumulativeProbability` in interface `RealDistribution`
Overrides:
  `inverseCumulativeProbability` in class `AbstractRealDistribution`
Parameters:
  `p` - the cumulative probability
Returns:
  the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)

### getSolverAbsoluteAccuracy

protected double getSolverAbsoluteAccuracy()
Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the solver absolute accuracy.
Since:
  2.1

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution. The mean is `scale * Gamma(1 + (1 / shape))`, where `Gamma()` is the Gamma-function.

Returns:
  the mean or `Double.NaN` if it is not defined

### calculateNumericalMean

protected double calculateNumericalMean()
used by `getNumericalMean()`

Returns:
  the mean of this distribution

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution. The variance is `scale^2 * Gamma(1 + (2 / shape)) - mean^2` where `Gamma()` is the Gamma-function.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### calculateNumericalVariance

protected double calculateNumericalVariance()
used by `getNumericalVariance()`

Returns:
  the variance of this distribution

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

The lower bound of the support is always 0 no matter the parameters.

Returns:
  lower bound of the support (always 0)

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

The upper bound of the support is always positive infinity no matter the parameters.

Returns:
  upper bound of the support (always `Double.POSITIVE_INFINITY`)

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`